local mhe_table = {
	"none",
	"random",
	"smoke_distorted",
	"spooc_bye",
	"spooc_bye_no_flash",
	"giant_cloaker_eyes",
	"mega_alien_eyes",
	"mega_rad_mutant_smoke_puff_no_random",
	"wolf_eyes",
	"glowing_eyes",
	"smoking_head"
}

local mhe_table_effect_head = {
	"none",
	"random",
	"mega_alien_eyes",
	"wolf_eyes",
	"glowing_eyes",
	"smoking_head"
}

local mhe_table_effect_body = {
	"none",
	"random",
	"smoke_distorted",
	"spooc_bye",
	"spooc_bye_no_flash",
	"giant_cloaker_eyes",
	"mega_rad_mutant_smoke_puff_no_random"
}

local mhe_table_color = {
	"random",
	"green",
	"blue",
	"cyan",
	"pink",
	"purple",
	"red",
	"white",
	"yellow"
}

local mhe_table_attach_to_spine = {
	"smoke_distorted",
	"spooc_bye",
	"spooc_bye_no_flash",
	"giant_cloaker_eyes"
}

local mhe_table_eye_effects = {
	"mega_alien_eyes",
	"wolf_eyes",
	"glowing_eyes"
}

local difficulty = tweak_data:difficulty_to_index(Global.game_settings and Global.game_settings.difficulty or "normal")
local faction = tweak_data.levels:get_ai_group_type()

Hooks:PostHook(CopDamage, "do_medic_heal", "do_medic_heal_effect", function(self)			
	local healing_effect_head = mhe_table_effect_head[MedicHealEffect.Options:GetValue("MHE_effect_head")]
	local healing_effect_body = mhe_table_effect_body[MedicHealEffect.Options:GetValue("MHE_effect_spine")]
	
	local effect_color_head = mhe_table_color[MedicHealEffect.Options:GetValue("MHE_effect_color_head")]
	local effect_color_body = mhe_table_color[MedicHealEffect.Options:GetValue("MHE_effect_color_spine")]
	
	local effect_adjustment = MedicHealEffect.Options:GetValue("MHE_effect_adjustments")
	local effect_color_sync = MedicHealEffect.Options:GetValue("MHE_effect_color_sync")
	
	if healing_effect_head == "random" then
		local effect_head_index = math.random(3, 6)
		healing_effect_head = mhe_table_effect_head[effect_head_index]
	end
	
	if healing_effect_body == "random" then
		local effect_body_index = math.random(3, 7)
		healing_effect_body = mhe_table_effect_body[effect_body_index]
	end
	
	
	if effect_color_sync and effect_color_head == "random" and effect_color_body == "random" then
		local effect_color_sync_index = math.random(2, 9)
		effect_color_head = mhe_table_color[effect_color_sync_index]
		effect_color_body = mhe_table_color[effect_color_sync_index]
	else
		if effect_color_head == "random" then
			local color_head_index = math.random(2, 9)
			effect_color_head = mhe_table_color[color_head_index]
		end
	
		if effect_color_body == "random" then
			local color_body_index = math.random(2, 9)
			effect_color_body = mhe_table_color[color_body_index]
		end
	end
	
	
	
	local get_obj_head = Idstring("Head")
	local get_obj_body = Idstring("Head")
	
	if table.contains(mhe_table_attach_to_spine, healing_effect_body) then
		get_obj_body = Idstring("Spine2")
	end
	
	local attach_to_unit_head = self._unit:get_object(get_obj_head)
	if not attach_to_unit_head then
		return
	end
	
	local attach_to_unit_body = self._unit:get_object(get_obj_body)
	if not attach_to_unit_body then
		return
	end
	
	local effect_pos = Vector3(0,0,0)
	if effect_adjustment and table.contains(mhe_table_eye_effects, healing_effect_head) then
		if self._unit:base()._tweak_table == "security"  or self._unit:base()._tweak_table == "security_mex" then
			effect_pos = Vector3(0,0,-2)
		end 
		
		if self._unit:base()._tweak_table == "heavy_swat"  or self._unit:base()._tweak_table == "fbi_heavy_swat" then
			if faction == "america" or faction == "zombie" or faction == "federales" then
				effect_pos = Vector3(0,0,5)
			elseif faction == "murkywater" then
				effect_pos = Vector3(0,0,-2) -- I wouldn't bother to add same pos change for murky that use same model as heavy_swat
			end	
		end
		
		if self._unit:base()._tweak_table == "zeal_heavy_swat" and faction == "murkywater"  then
			effect_pos = Vector3(0,0,-2)
		end
	
		if (self._unit:base()._tweak_table == "city_swat" or self._unit:base()._tweak_table == "zeal_swat") and faction == "murkywater" then
			effect_pos = Vector3(0,1,-2)
		end
	
		if self._unit:base()._tweak_table == "taser" then
			if (difficulty == 8 and faction == "america") or faction == "murkywater" then
				effect_pos = Vector3(0,-2,5)
			elseif faction == "russia" then
			else
				effect_pos = Vector3(0,0,5)
			end
		end
	
		if faction == "russia" then
			if self._unit:base()._tweak_table == "taser" or self._unit:base()._tweak_table == "tank" then
			else
				effect_pos = Vector3(0,-1,-3)
			end
		end
	end
	
	
	if self._unit:contour() then
		if healing_effect_head == "none" then
		else
			self._healing_effect_head = World:effect_manager():spawn({
				effect = Idstring("effects/medic_heal_effect/"..effect_color_head.."/"..healing_effect_head),
				parent = attach_to_unit_head,
				position = effect_pos
			})
		end
		if healing_effect_body == "none" then
		else
			self._healing_effect_body = World:effect_manager():spawn({
				effect = Idstring("effects/medic_heal_effect/"..effect_color_body.."/"..healing_effect_body),
				parent = attach_to_unit_body,
				--position = effect_pos
			})
		end
		if MedicHealEffect.Options:GetValue("MHE_disable_outline") then
			self._unit:contour():remove("medic_heal", false)
		end
		self._unit:contour():flash("medic_heal", MedicHealEffect.Options:GetValue("MHE_ping_intensity"))

	end
	
end)

Hooks:PostHook(CopDamage, "die", "die_medic_heal_effect", function(self)			
	if self._healing_effect then
		World:effect_manager():fade_kill(self._healing_effect_head)
		World:effect_manager():fade_kill(self._healing_effect_body)
	end
end)